## haskell-hlist 2.0+darcs20070316

=== Makefile ===
##############################################################################
#
# Useful make targets
#
# make test        -- run all GHC- and Hugs-based test cases.
# make clean       -- remove all generated and temporary and backup files
# make ghci        -- start an HList ghci session
#


##############################################################################
#
# Some variables
#

ghci = ghci -fglasgow-exts \
		-fallow-overlapping-instances \
		-fallow-undecidable-instances
ghc-favourite  = MainGhcGeneric1.hs
hugs-favourite = MainHugsTTypeable.hs


##############################################################################
#
# By default tell user to have a look at the Makefile's header.
#

all:
	@echo
	@echo "*****************************************************"
	@echo "* See the Makefile's header for reasonable targets. *"
	@echo "* Perhaps, you may want to run make test?           *"
	@echo "*****************************************************"
	@echo


##############################################################################
#
# Start a GHCI session for the favoured GHC model
#

ghci:
	ghci ${ghc-favourite}


##############################################################################
#
# Start a Hugs session for the favoured Hugs model
#

hugs:
	hugs -98 +o ${hugs-favourite}


##############################################################################
#
# Run test cases for both GHCI and Hugs
#

test:
	make test-ghc
	make test-hugs

test-ghc:
#
# The favoured GHC model
#
	${ghci} ${ghc-favourite} -v0 < Main.in > MainGhcGeneric1.out
	diff -b MainGhcGeneric1.out MainGhcGeneric1.ref
#
# The GHC model with TTypeable-based type equality
#
	${ghci} MainGhcTTypeable.hs -v0 < Main.in > MainGhcTTypeable.out
	diff -b MainGhcTTypeable.out MainGhcTTypeable.ref
#
# Run test cases as posted on mailing lists
#
	${ghci} MainPatternMatch.hs -v0 < Main.in > MainPatternMatch.out
	diff -b MainPatternMatch.out MainPatternMatch.ref
	${ghci} MainPosting-040607.hs -v0 < Main.in > MainPosting-040607.out
	diff -b MainPosting-040607.out MainPosting-040607.ref
	${ghci} MainPosting-051106.hs -v0 < Main.in > MainPosting-051106.out
	diff -b MainPosting-051106.out MainPosting-051106.ref
	${ghci} HSequence.hs -v0 < Main.in > HSequence.out
	diff -b HSequence.out HSequence.ref 
#
# Yet another generic type equality
#
	${ghci} MainGhcGeneric2.hs -v0 < Main.in > MainGhcGeneric2.out
	diff -b MainGhcGeneric2.out MainGhcGeneric2.ref
#
# Yet another generic type cast
#
	${ghci} MainGhcGeneric3.hs -v0 < Main.in > MainGhcGeneric3.out
	diff -b MainGhcGeneric3.out MainGhcGeneric3.ref

test-hugs:
#
# The Hugs model with TTypeable-based type equality
#
	runhugs -98 +o ${hugs-favourite} < Main.in > MainHugsTTypeable.out
	diff -b MainHugsTTypeable.out MainHugsTTypeable.ref


##############################################################################
#
# Approve generated output as test results
#

copy:
	cp MainGhcGeneric1.out MainGhcGeneric1.ref
	cp MainGhcTTypeable.out MainGhcTTypeable.ref
	cp MainHugsTTypeable.out MainHugsTTypeable.ref
	cp MainPosting-040607.out MainPosting-040607.ref
	cp MainGhcGeneric2.out MainGhcGeneric2.ref
	cp MainGhcGeneric3.out MainGhcGeneric3.ref


##############################################################################
#
# Precompilation of HList.
#
# BEWARE!!!
# This may not work even if interpretation works.
# Depending on versions and platforms.
# Here is one scenario that leads to crashes:
#  - Tested under GHC 6.4 and Windows XP
#  - Compile CommonMain.hs *without* -O
#  - Run test cases with "make test"
#  - Runtime crashes in the middle of printing main's output.
#

CommonMain.o: *.hs Makefile
	rm -f *.o
	ghc  \
		-fglasgow-exts \
		-fallow-overlapping-instances \
		-fallow-undecidable-instances \
		-c -O \
		--make \
		CommonMain.hs

Main.exe: *.hs Makefile
	rm -f *.o
	ghc  \
		-fglasgow-exts \
		-fallow-overlapping-instances \
		-fallow-undecidable-instances \
		-o Main.exe -O \
		--make \
		Main.hs


##############################################################################
#
# Clean up directory
#

clean:
	rm -f *~
	rm -f *.out
	rm -f *.o
	rm -f *.exe
	rm -f *.hi
	rm -f index.html HList.zip


##############################################################################
#
# Target used by the authors for distributing OOHaskell.
#

distr:
	cat pre.html README post.html > index.html
	rm -rf HList.zip
	rm -rf HList
	mkdir -p HList
	cp --preserve *.hs *.lhs Makefile Main.in *.ref README LICENSE ChangeLog HList
	zip -r HList.zip HList


##############################################################################

## haskell-hlist 0.2

=== debian/changelog ===
haskell-hlist (1:0.2-1) unstable; urgency=low

  [ Marco Túlio Gontijo e Silva ]
  * debian/source/format: Use 3.0 (quilt).

  [ Joachim Breitner ]
  * Upload package as released on cabal, bump epoch 
  * Depend on ghc6 (>= 6.12.1-13)
  * Patch: Add TypeOperators

 -- Joachim Breitner <nomeata@debian.org>  Fri, 05 Mar 2010 12:47:38 +0100

haskell-hlist (2.0+darcs20070929-2) unstable; urgency=low

  [ Marco Túlio Gontijo e Silva ]
  * debian/control: Change Priority: to extra.
  * debian/watch: Use format that works for --download-current-version.
  * debian/watch: Add .tar.gz to downloaded filename.
  * debian/watch: Include package name in downloaded .tar.gz.
  * debian/watch: Remove spaces, since they're not allowed by uscan.
  * debian/control: Add field Provides: ${haskell:Provides} to -dev and
    -prof packages.
  * debian/control: Add Vcs-Darcs: field.
  * debian/control: Use Vcs-Browser: field.
  * debian/control: Bump Standards-Version: to 3.8.4, no changes needed.

  [ Joachim Breitner ]
  * Bump haskell-devscripts dependency to 0.7
  * Remove hugs package

 -- Joachim Breitner <nomeata@debian.org>  Sat, 20 Feb 2010 16:17:03 +0100

haskell-hlist (2.0+darcs20070929-1.1) unstable; urgency=low

  * Adopt for the Debian Haskell Group, thanks to Kaol for his maintenance.
  * Change packaging to current common practice
  * Do not depend on libghc6-base-dev (Closes: #529022) 
  * Rebuilding will closes: #520308

 -- Joachim Breitner <nomeata@debian.org>  Thu, 30 Jul 2009 19:52:30 +0200

haskell-hlist (2.0+darcs20070929-1) unstable; urgency=low

  * New upstream release
  * Built for ghc 6.8.2. (Closes: #445759)
  * Use cdbs and haskell-devscripts instead of haskell-utils.
  * Leave examples uninstalled as they don't seem to be relevant to the
    current HList version.
  * Added a -prof package for ghc6 and a hugs library package.

 -- Kari Pahula <kaol@debian.org>  Wed, 23 Jan 2008 11:49:23 +0200

haskell-hlist (2.0+darcs20070316-2) unstable; urgency=low

  * Rebuilt and updated dependencies for ghc 6.6.1

 -- Kari Pahula <kaol@debian.org>  Mon, 14 May 2007 15:05:09 +0300

haskell-hlist (2.0+darcs20070316-1) unstable; urgency=low

  * Initial release (Closes: #413826)
  * Used Ian Lynagh's Generic Haskell cabal library debian/rules v0.6

 -- Kari Pahula <kaol@debian.org>  Fri, 20 Apr 2007 19:07:22 +0300

=== debian/control ===
Source: haskell-hlist
Section: haskell
Priority: extra
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Standards-Version: 3.8.4
Build-Depends:
 cdbs,
 debhelper (>= 7),
 haskell-devscripts (>= 0.7),
 ghc6 (>= 6.12.1-13),
 ghc6-prof,
Homepage: http://homepages.cwi.nl/~ralf/HList/
Vcs-Darcs: http://darcs.debian.org/pkg-haskell/haskell-hlist
Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/haskell-hlist

Package: libghc6-hlist-dev
Architecture: any
Depends: ${haskell:Depends}, ${shlibs:Depends}, ${misc:Depends}
Recommends: ${haskell:Recommends}
Suggests: ${haskell:Suggests}
Provides: ${haskell:Provides}
Description: Haskell library for strongly typed heterogeneous collections
 A heterogeneous collection is a datatype that is capable of storing
 data of different types, while providing operations for look-up,
 update, iteration, and others. There are various kinds of
 heterogeneous collections, differing in representation, invariants,
 and access operations.
 .
 HList is a Haskell library providing strongly typed heterogeneous
 collections including extensible records.

Package: libghc6-hlist-prof
Architecture: any
Depends: ${haskell:Depends}, ${misc:Depends}
Recommends: ${haskell:Recommends}
Suggests: ${haskell:Suggests}
Provides: ${haskell:Provides}
Description: Haskell library for strongly typed heterogeneous collections
 A heterogeneous collection is a datatype that is capable of storing
 data of different types, while providing operations for look-up,
 update, iteration, and others. There are various kinds of
 heterogeneous collections, differing in representation, invariants,
 and access operations.
 .
 HList is a Haskell library providing strongly typed heterogeneous
 collections including extensible records.

=== debian/watch ===
version=3
opts="downloadurlmangle=s|archive/([\w\d_-]+)/([\d\.]+)/|archive/$1/$2/$1-$2.tar.gz|,\
filenamemangle=s|(.*)/$|HList-$1.tar.gz|" \
    http://hackage.haskell.org/packages/archive/HList \
    ([\d\.]*\d)/

## haskell-hlist 2.0+darcs20070929

=== Makefile ===
--- 
+++ 
@@ -49,7 +49,7 @@
 #
 
 hugs:
-	hugs -98 +o ${hugs-favourite}
+	hugs -98 +o -isrc ${hugs-favourite}
 
 
 ##############################################################################
@@ -180,3 +180,8 @@
 
 
 ##############################################################################
+
+commit:
+	darcs record -a -m "Committed from the Makefile"
+	darcs push -a
+
